"""Add api tokens

Revision ID: 0a82dc419cb1
Revises: c0ceb4bf69e3
Create Date: 2024-06-05 08:47:57.874156

"""

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

import clowm.db.types

# revision identifiers, used by Alembic.
revision: str = "0a82dc419cb1"
down_revision: str | None = "c0ceb4bf69e3"
branch_labels: str | Sequence[str] | None = None
depends_on: str | Sequence[str] | None = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "api_token",
        sa.Column("token_id", clowm.db.types.SQLUUID(length=16), nullable=False),
        sa.Column("name", sa.String(length=63), nullable=False),
        sa.Column("token", clowm.db.types.Token(length=32), nullable=False),
        sa.Column("uid", clowm.db.types.SQLUUID(length=16), nullable=False),
        sa.Column("expires_at", mysql.INTEGER(unsigned=True), nullable=True),
        sa.Column("last_used", mysql.INTEGER(unsigned=True), nullable=True),
        sa.Column("scopes", clowm.db.types.SQLIntFlag(flag_type=clowm.db.types.ApiTokenScopesDB), nullable=False),
        sa.Column("created_at", mysql.INTEGER(unsigned=True), nullable=False),
        sa.Column("updated_at", mysql.INTEGER(unsigned=True), nullable=False),
        sa.ForeignKeyConstraint(["uid"], ["user.uid"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("token_id"),
    )
    op.create_index(op.f("ix_api_token_token"), "api_token", ["token"], unique=False)
    op.create_index(op.f("ix_api_token_token_id"), "api_token", ["token_id"], unique=True)
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_api_token_token_id"), table_name="api_token")
    op.drop_index(op.f("ix_api_token_token"), table_name="api_token")
    op.drop_table("api_token")
    # ### end Alembic commands ###
